moSetGetMohSLOT = {};

function moSetGetMohSLOT:setRenderViewLines(whichSLOT, down, multiple)
	local whichSubSLOT = whichSLOT or "masterSLOT_";	
	local multiple = multiple or false;
	local nextView = 1;
	if multiple then
		local viewLines = math.abs(moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2] - moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1])+1;
		if down then
			if moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2]+viewLines <= moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[3] then
				nextView = viewLines;
			else
				nextView = moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[3]-moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2];
			end;
		else
			if moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1]-viewLines >= 1 then
				nextView = viewLines;
			else
				moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1] = 1;
				moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2] = math.floor(moSetGetOverlays.slot[whichSubSLOT].height/(moSetGetOverlays.slot[whichSubSLOT].txtHeight));
				return;
			end;
		end;
	end;
	if down then		
		if moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2] >= moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[3] then return;end;
		moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1] = moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1]+nextView;
		moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2] = moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2]+nextView;
	else
		if moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1] <= 1 then return;end;		
		moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1] = moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[1]-nextView;
		moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2] = moSetGetOverlays.slot[whichSubSLOT].renderViewLines.bounds[2]-nextView;
	end;	
end;

function moSetGetMohSLOT:setRenderViewText(whichSLOT, right)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if right then
		if moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[2] >= moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[3] then return;end;
		moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[1] = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[1]+1;
		moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[2] = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[2]+1;
	else
		if moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[1] <= 1 then return;end;
		moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[1] = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[1]-1;
		moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[2] = moSetGetOverlays.slot[whichSubSLOT].renderViewText.bounds[2]-1;
	end;				
	moDraw.mohSLOT:getSlideRegulatorOverlay(false, 0.0008, whichSubSLOT);
end;

function moSetGetMohSLOT:resetWidthHeightText(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";	
	moSetGetOverlays.slot[whichSubSLOT].txtHeight = moSetGetOverlays.slot[whichSubSLOT].design["dragDrop"].height+moSetGetOverlays.slot[whichSubSLOT].verticalTxtDistance;
	moSetGetOverlays.slot[whichSubSLOT].size = moSetGetExtras:optiHeightSize(self, moSetGetOverlays.slot[whichSubSLOT].txtHeight, "G", moSetGetOverlays.slot[whichSubSLOT].size);
	moSetGetOverlays.slot[whichSubSLOT].letterWidth = getTextWidth(moSetGetOverlays.slot[whichSubSLOT].size, "G");
	setTextBold(true);
	moSetGetOverlays.slot[whichSubSLOT].letterWidthBold = getTextWidth(moSetGetOverlays.slot[whichSubSLOT].size, "G");
	setTextBold(false);	
end;

function moSetGetMohSLOT:resetRenderViewLines(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local maxBounds = math.floor(moSetGetOverlays.slot[whichSubSLOT].height/(moSetGetOverlays.slot[whichSubSLOT].txtHeight));	
	if maxBounds < 1 then maxBounds = 1;end;
	moSetGetOverlays.slot[whichSubSLOT].renderViewLines = {bounds={1, maxBounds, maxBounds}};	
end;

function moSetGetMohSLOT:resetRenderViewText(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";	
	--local maxBounds = moSetGetOverlays.slot[whichSubSLOT].width/moSetGetOverlays.slot[whichSubSLOT].letterWidthBold;
	local txt = "a";
	local size = moSetGetOverlays.slot[whichSubSLOT].size;
	local width = moSetGetOverlays.slot[whichSubSLOT].width;
	local txtLength = 0;
	local maxTxtLength = 0;
	setTextBold(true);
	while  maxTxtLength <= txtLength do		
		txtLength = getTextLineLength(size, txt, width);
		txt = txt.. "a";
		maxTxtLength = maxTxtLength+1;
	end;
	setTextBold(false);	
	local maxBounds = string.len(txt)+(moSetGetOverlays.slot[whichSubSLOT].txtWidthFix);	
	moSetGetOverlays.slot[whichSubSLOT].renderViewText = {bounds={1, maxBounds, maxBounds, false}};	
end;

function moSetGetMohSLOT:defaultWidthHeight(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";	
	moSetGetMohSLOT:resetWidthHeightText(whichSubSLOT);
	moSetGetOverlays.slot[whichSubSLOT].defaultWidth = moSetGetOverlays.slot[whichSubSLOT].design["groundMaster"].width;
	moSetGetOverlays.slot[whichSubSLOT].width = moSetGetOverlays.slot[whichSubSLOT].defaultWidth;	
	moSetGetOverlays.slot[whichSubSLOT].defaultHeight = (moSetGetOverlays.slot[whichSubSLOT].txtHeight+moSetGetOverlays.slot[whichSubSLOT].verticalTxtDistance); --*7; --*7 for Setting	
	moSetGetOverlays.slot[whichSubSLOT].height = moSetGetOverlays.slot[whichSubSLOT].defaultHeight;
	if moSetGetOverlays.slot[whichSubSLOT].setting.on then moSetGetOverlays.slot[whichSubSLOT].height = moSetGetOverlays.slot[whichSubSLOT].height*7;end;
	moSetGetMohSLOT:resetRenderViewLines(whichSubSLOT);
	moSetGetMohSLOT:resetRenderViewText(whichSubSLOT);
end;

--mod open slot Normal
function moSetGetMohSLOT.openSLOT(whichSLOT, openSlot)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if openSlot ~= nil and openSlot then		
		if moSetGetOverlays.slot[whichSubSLOT] ~= nil and not moSetGetOverlays.slot[whichSubSLOT].isOpen then moSetGetOverlays.slot[whichSubSLOT].isOpen = true;end;		
	end;
end;
--mod open slot Normal

--mod close slot Normal
function moSetGetMohSLOT.closeSLOT(whichSLOT, closeSlot)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if closeSlot ~= nil and closeSlot then		
		if moSetGetOverlays.slot[whichSubSLOT] ~= nil and moSetGetOverlays.slot[whichSubSLOT].isOpen then moSetGetOverlays.slot[whichSubSLOT].isOpen = false;end;		
	end;
end;
--mod close slot Normal

--mod smallView slot open/close
function moSetGetMohSLOT.smallViewSLOT(whichSLOT, smallViewSlot)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if smallViewSlot ~= nil and smallViewSlot then		
		if moSetGetOverlays.slot[whichSubSLOT] ~= nil then if moSetGetOverlays.slot[whichSubSLOT].smallView then moSetGetOverlays.slot[whichSubSLOT].smallView = false;else moSetGetOverlays.slot[whichSubSLOT].smallView = true;end;end;		
	end;
end;
--mod smallView slot open/close

--mod setting cmd slot on/off
function moSetGetMohSLOT.settingCmdSLOT(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if moSetGetOverlays.slot[whichSubSLOT].setting.cmdSelect then
		moSetGetOverlays.slot[whichSubSLOT].setting.cmdSelect = false;
	else
		moSetGetOverlays.slot[whichSubSLOT].setting.cmdSelect = true;
	end;
end;	
--mod setting cmd slot on/off

--mod setting slot on/off
function moSetGetMohSLOT.settingOnOffSLOT(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	if moSetGetOverlays.slot[whichSubSLOT].setting.on then 
		moSetGetOverlays.slot[whichSubSLOT].setting.on = false;
		moSetGetOverlays.slot[whichSubSLOT].output={};
		moSetGetOverlays.slot[whichSubSLOT].setting.output = {};
	else 
		moSetGetOverlays.slot[whichSubSLOT].setting.on = true;		
	end;
end;

--mod settingLine slot open/close
function moSetGetMohSLOT.settingLineSLOT(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";		
	if moSetGetOverlays.slot[whichSubSLOT] ~= nil then 
		if moSetGetOverlays.slot[whichSubSLOT].settingLine then 
			moSetGetOverlays.slot[whichSubSLOT].settingLine = false;
			if moSetGetOverlays.slot[whichSubSLOT].setting.on then moSetGetMohSLOT.settingOnOffSLOT(whichSubSLOT);end;
		else 
			moSetGetOverlays.slot[whichSubSLOT].settingLine = true;
		end;
	end;		
end;
--mod settingLine slot open/close

function moSetGetMohSLOT:editSlotName(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local modAppValues = {
		dialogTitel=tostring(MultiOverlayV3.metadata.title); 
		dialogText2="Edit Slot Name (min length 4)";		
		onSaveCallback=moSetGetMohSLOT.saveEditSlotName;
		checkText = {inputTextAppendEnd="", maxLengthText=30, minLengthText=4};
		ownValues = whichSubSLOT;
		visibleButton = {saveButton=true, checkButton=false};
	};
	return g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("GuiMenueInOutPutTextDialog", modAppValues);
end;

function moSetGetMohSLOT.saveEditSlotName(...)
	if ... ~= nil and type(...) == "table" then
		local args = ...;				
		if args.inputText ~= nil and string.len(args.inputText) >= 4 then
			moSetGetOverlays.slot[args.ownValues].name = tostring(args.inputText);
			g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;			
			for a=1, #MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd do				
				if MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd[a].name == "openCloseSlot_".. args.ownValues then
					MultiOverlayV3.cmdTable[MultiOverlayV3.ownCmdTable].cmd[a].displayName = "Open/Close Slot ".. tostring(args.inputText);
					moSetGetGuiMenue:refreshAllSideCmdPullDownLine();
					
					local defaultPageSide = 1; --ändern wenn die seite verschoben wird
					local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );			
					if getThisButtonPage == nil then return;end;
					local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
					if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;
					local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
					buttonTable.cmdTable = moSetGetGuiMenue:getNewPullDownTable(4);
					slotSettingsSide1:resetSlotGuiMenue();
					break;
				end;
			end;
		end;		
	end;
	g_currentMission.guiMenue.guiSetGet:closeLsOrGuiMenueDialog(); --->reset other next Mods not start Dialog
end;

function moSetGetMohSLOT:getSLOTs()	
	local mohSLOTs = {};
	if moSetGetOverlays.slot ~= nil then		
		for whichSLOT, value in pairs(moSetGetOverlays.slot) do				
			mohSLOTs[#mohSLOTs+1] = {tostring(whichSLOT), Utils.getNoNil(moSetGetOverlays.slot[whichSLOT].name, "")};
		end;		
	end;
	return mohSLOTs;
end;

function moSetGetMohSLOT:getOpenSLOTs()	
	local openAreas = {};
	if moSetGetOverlays.slot ~= nil then --and #moSetGetOverlays.slot > 0 then
		--print("Begin")
		for key, value in pairs(moSetGetOverlays.slot) do				
			if value.isOpen then
				openAreas[#openAreas+1] = tostring(key);				
			end;
		end;
		--print("End")		
	end;
	return openAreas;
end;